<html>
<head>
<title>OGRE: Ogre::ShadowCameraSetup Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1ShadowCameraSetup.html">ShadowCameraSetup</a></div>
<h1>Ogre::ShadowCameraSetup Class Reference</h1><!-- doxytag: class="Ogre::ShadowCameraSetup" -->This class allows you to plug in new ways to define the camera setup when rendering and projecting shadow textures.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreShadowCameraSetup_8h-source.html">OgreShadowCameraSetup.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::ShadowCameraSetup:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1ShadowCameraSetup-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCameraSetup.html#672a8fa796007d122d3555b09c611d2e">getShadowCamera</a> (const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *sm, const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam, const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *vp, const <a class="el" href="classOgre_1_1Light.html">Light</a> *light, <a class="el" href="classOgre_1_1Camera.html">Camera</a> *texCam) const =0</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Function to implement -- must set the shadow camera properties.  <a href="#672a8fa796007d122d3555b09c611d2e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1ShadowCameraSetup.html#790a06721a8e3c6f48218aa659c334ef">~ShadowCameraSetup</a> ()</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Need virtual destructor in case subclasses use it.  <a href="#790a06721a8e3c6f48218aa659c334ef"></a><br></td></tr>
</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
This class allows you to plug in new ways to define the camera setup when rendering and projecting shadow textures. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>The default projection used when rendering shadow textures is a uniform frustum. This is pretty straight forward but doesn't make the best use of the space in the shadow map since texels closer to the camera will be larger, resulting in 'jaggies'. There are several ways to distribute the texels in the shadow texture differently, and this class allows you to override that. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd><a class="el" href="namespaceOgre.html">Ogre</a> is provided with several alternative shadow camera setups, including LiSPSM (<a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html" title="Implements the Light Space Perspective Shadow Mapping Algorithm.">LiSPSMShadowCameraSetup</a>) and <a class="el" href="classOgre_1_1Plane.html" title="Defines a plane in 3D space.">Plane</a> Optimal (<a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html" title="Implements the plane optimal shadow camera algorithm.">PlaneOptimalShadowCameraSetup</a>). Others can of course be written to incorporate other algorithms. All you have to do is instantiate one of these classes and enable it using <a class="el" href="classOgre_1_1SceneManager.html#dbe1da236689cdd20690d5da950dce33" title="Set the shadow camera setup to use for all lights which don&#39;t have their own...">SceneManager::setShadowCameraSetup</a> (global) or <a class="el" href="classOgre_1_1Light.html#4a6f664fade2ac14d1ed5910b0d1a21a" title="Set this light to use a custom shadow camera when rendering texture shadows.">Light::setCustomShadowCameraSetup</a> (per light). In both cases the instance is wrapped in a <a class="el" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is...">SharedPtr</a> which means it will be deleted automatically when no more references to it exist. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Shadow map matrices, being projective matrices, have 15 degrees of freedom. 3 of these degrees of freedom are fixed by the light's position. 4 are used to affinely affect z values. 6 affinely affect u,v sampling. 2 are projective degrees of freedom. This class is meant to allow custom methods for handling optimization. </dd></dl>

<p>Definition at line <a class="el" href="OgreShadowCameraSetup_8h-source.html#l00063">63</a> of file <a class="el" href="OgreShadowCameraSetup_8h-source.html">OgreShadowCameraSetup.h</a>.</p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="790a06721a8e3c6f48218aa659c334ef"></a><!-- doxytag: member="Ogre::ShadowCameraSetup::~ShadowCameraSetup" ref="790a06721a8e3c6f48218aa659c334ef" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::ShadowCameraSetup::~ShadowCameraSetup           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Need virtual destructor in case subclasses use it. 
<p>

<p>Definition at line <a class="el" href="OgreShadowCameraSetup_8h-source.html#l00070">70</a> of file <a class="el" href="OgreShadowCameraSetup_8h-source.html">OgreShadowCameraSetup.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="672a8fa796007d122d3555b09c611d2e"></a><!-- doxytag: member="Ogre::ShadowCameraSetup::getShadowCamera" ref="672a8fa796007d122d3555b09c611d2e" args="(const SceneManager *sm, const Camera *cam, const Viewport *vp, const Light *light, Camera *texCam) const =0" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::ShadowCameraSetup::getShadowCamera           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1SceneManager.html">SceneManager</a> *&nbsp;</td>
          <td class="paramname"> <em>sm</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Viewport.html">Viewport</a> *&nbsp;</td>
          <td class="paramname"> <em>vp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Light.html">Light</a> *&nbsp;</td>
          <td class="paramname"> <em>light</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>texCam</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [pure virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Function to implement -- must set the shadow camera properties. 
<p>

<p>Implemented in <a class="el" href="classOgre_1_1DefaultShadowCameraSetup.html#ff9f6fef8bacec6bfa259aced847bc6a">Ogre::DefaultShadowCameraSetup</a>, <a class="el" href="classOgre_1_1FocusedShadowCameraSetup.html#4859f949e592b63e5f211f85f510cb37">Ogre::FocusedShadowCameraSetup</a>, <a class="el" href="classOgre_1_1LiSPSMShadowCameraSetup.html#d8969d629ddf8c9e01f22c5342888b99">Ogre::LiSPSMShadowCameraSetup</a>, and <a class="el" href="classOgre_1_1PlaneOptimalShadowCameraSetup.html#c5f4e3dc347c87d35244064665448937">Ogre::PlaneOptimalShadowCameraSetup</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShadowCameraSetup_8h-source.html">OgreShadowCameraSetup.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:53:34 2008
</p>
</body>
</html>
